package org.jboss.example;

import static java.lang.System.out;

import java.util.ArrayList;
import java.util.List;

import javax.batch.runtime.BatchRuntime;
import javax.batch.runtime.BatchStatus;
import javax.batch.runtime.JobExecution;
import javax.batch.runtime.JobInstance;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;

import org.apache.commons.lang3.builder.ReflectionToStringBuilder;

@Path("batch")
public class Batching {

	public Batching() {
	}

	@GET
	@Path("batchlet")
	public void batchlet() {
		long execId = BatchRuntime.getJobOperator().start("batchletJob", null);
		JobExecution je = BatchRuntime.getJobOperator().getJobExecution(execId);
		while (je.getBatchStatus() != BatchStatus.COMPLETED
				&& je.getBatchStatus() != BatchStatus.FAILED) {
			out.println("JO: " + je.getBatchStatus().name());
			try {
				Thread.sleep(500);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
		out.println("JO: " + je.getBatchStatus().name());
	}

	@GET
	@Path("chunk")
	public void chunk() {
		long execId = BatchRuntime.getJobOperator().start("chunkJob", null);
	}

	@GET
	@Path("complex")
	public void complex() {
		long execId = BatchRuntime.getJobOperator().start("complexJob", null);
	}

	@GET
	@Path("jobs")
	@Produces("application/json")
	public Object jobs() {
		StringBuilder sb = new StringBuilder();
		List<JobExecution> execs = new ArrayList<>();
		
		for (String jobName : BatchRuntime.getJobOperator().getJobNames()) {
			for (JobInstance job : BatchRuntime.getJobOperator()
					.getJobInstances(jobName, 0, 1000)) {
				for (JobExecution exec : BatchRuntime.getJobOperator()
						.getJobExecutions(job)) {
					sb.append(new ReflectionToStringBuilder(exec).toString() + "\n");
					execs.add(exec);
				}
			}
		}
		return execs;
	}
}
