package org.jboss.example;

import java.util.ArrayList;
import java.util.List;

import javax.el.ELProcessor;
import javax.ws.rs.GET;
import javax.ws.rs.Path;

import org.jboss.example.bean.User;

@Path("el")
public class ExpressionLanguage {

	List<User> employees = new ArrayList<>();
	
	public ExpressionLanguage() {
		employees.add(new User(1, "Josef", "Novak", 40));
		employees.add(new User(2, "Frantisek", "Vomacka", 25));
		employees.add(new User(3, "Karel", "Vopicka", 62));
	}
	
	@GET
	@Path("defbean")
	public String defBean() {
		ELProcessor elp = new ELProcessor();
		elp.defineBean("emps", employees);
		return elp.eval("emps[1]").toString();
	}

	@GET
	@Path("lambda")
	public String lambda() {
		ELProcessor elp = new ELProcessor();
		elp.eval("a = ((x,y) -> x.length() + y.length())");
		return elp.eval("a('abc', 'xy') + 3").toString();
	}
	
	@GET
	@Path("stream/map")
	public String map() {
		ELProcessor elp = new ELProcessor();
		elp.defineBean("emps", employees);
		return elp.eval("emps.stream().map(x -> x.name += ' ' += x.surname).toList()").toString();
	}

	@GET
	@Path("stream/filter")
	public String filter() {
		ELProcessor elp = new ELProcessor();
		elp.defineBean("emps", employees);
		return elp.eval("emps.stream().filter(x -> x.age > 60).toList()").toString();
	}

	@GET
	@Path("stream/reduce")
	public String reduce() {
		ELProcessor elp = new ELProcessor();
		elp.defineBean("emps", employees);
		return elp.eval("emps.stream().reduce(0, (acc, x) -> acc + x.age)").toString();
	}
}
