package org.jboss.example;

import java.io.IOException;

import javax.servlet.AsyncContext;
import javax.servlet.ServletException;
import javax.servlet.WriteListener;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

@WebServlet(urlPatterns = "/AsyncServlet", asyncSupported = true)
public class Servlet extends HttpServlet {
	
	static class SimpleWriteListener implements WriteListener {
		
		public SimpleWriteListener(AsyncContext ctx) {
			super();
			this.ctx = ctx;
		}

		private AsyncContext ctx;
		
		@Override
		public void onError(Throwable arg0) {
		}

		@Override
		public void onWritePossible() throws IOException {
			System.out.println("onWritePossible");
			ctx.getResponse().getOutputStream().println("Response OK");
			ctx.complete();
		}
		
	}
	
	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public Servlet() {
        super();
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		AsyncContext actx = request.startAsync();
		response.getOutputStream().setWriteListener(new SimpleWriteListener(actx));
		System.out.println("doGet completed");
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
	}

}


