package org.jboss.example;

import java.util.Set;

import javax.inject.Inject;
import javax.validation.ConstraintViolation;
import javax.validation.Validator;
import javax.validation.ValidatorFactory;
import javax.validation.constraints.Size;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.QueryParam;

import org.jboss.example.bean.User;

@Path("validation")
public class Validation {

	@Inject
	Validator validator;
	
	@Inject
	ValidatorFactory validatorFactory;
	
	@GET
	@Path("dbc")
	public String contract(@QueryParam("msg") @Size(max = 5) String msg) {
		return msg;
	}

	@GET
	@Path("validator")
	public String validator(@QueryParam("name") String name) {
		ValidatorFactory vf = javax.validation.Validation.buildDefaultValidatorFactory();
		Validator val = vf.getValidator();
		
		User u = new User(10, name, "Fixed", 20);
		Set<ConstraintViolation<User>> violations = validator.validate(u);
		StringBuilder sb = new StringBuilder("Violations:\n");
		for (ConstraintViolation<User> v: violations) {
			sb.append(v.getMessage()).append('\n');
		}
		return sb.toString();
	}
}
